# 文档书写规范
## 工具
本文档采用Markdown编写，使用基础语法，不加入任何扩展语法

## 格式规范
每一个文档使用`#`作为文档大标题  
`##`为1级标题  
`###`为2级标题  
`####`为3级标题  
`#####`为4级标题  

如进行文档内跳转，使用以下格式：  
```
[XXX](#YYY)
[板级支持包BSP](#板级支持包bsp)
```
`XXX`为此超链接在文档中显示的内容  
`YYY`为跳转的目标标题，所有英文字面为小写  

如进行网页跳转，使用以下格式：  
```
[XXX](#YYY)
[Python官网](https://www.python.org/)
```
`XXX`为此超链接在文档中显示的内容  
`YYY`为跳转的目标网址  
可与插入图片嵌套使用  

如插入图片，使用以下格式：  
```
![XXX](YYY)
![soc架构](/pic/img/soc架构.svg) 
```
`XXX`为图片名称  
`YYY`为图片相对路径或网络图床  

如进行仓库内页面跳转，使用以下格式：  
```
[XXX](YYY)
[处理器文档导航页](/doc/文档导航.md)
```
`XXX`为此超链接在文档中显示的内容  
`YYY`为跳转的相对地址  

如插入表格，使用以下格式：  
```
|表头0|表头1|表头2|
|-|-|-|
|AAA|BBB|CCC|
|EEE|FFF|DDD|
```
`|`数量严格配对  
